package org.eco.als.listener;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.ObjectUtil;
import com.alibaba.excel.context.AnalysisContext;
import com.alibaba.excel.event.AnalysisEventListener;
import lombok.extern.slf4j.Slf4j;
import org.eco.als.domain.bo.ContactsBo;
import org.eco.als.domain.vo.ContactsImportVo;
import org.eco.als.domain.vo.ContactsVo;
import org.eco.als.service.IContactsService;
import org.eco.common.core.core.domain.model.LoginUser;
import org.eco.common.core.utils.SpringUtils;
import org.eco.common.core.utils.ValidatorUtils;
import org.eco.common.excel.core.ExcelListener;
import org.eco.common.excel.core.ExcelResult;
import org.eco.common.excel.entity.ExcelResultRes;

import java.util.List;

/**
 * 通讯录自定义导入
 *
 * @author wgk
 */
@Slf4j
public class ContactsImportListener extends AnalysisEventListener<ContactsImportVo> implements ExcelListener<ContactsImportVo> {
    private final IContactsService contactsService;

    private final Boolean isUpdateSupport;
    private final LoginUser loginUser;
    private int successNum = 0;
    private int failureNum = 0;
    private final StringBuilder successMsg = new StringBuilder();
    private final StringBuilder failureMsg = new StringBuilder();

    public ContactsImportListener(Boolean isUpdateSupport, LoginUser loginUser) {
        this.contactsService = SpringUtils.getBean(IContactsService.class);
        this.isUpdateSupport = isUpdateSupport;
        this.loginUser = loginUser;
    }

    @Override
    public void invoke(ContactsImportVo contactsVo, AnalysisContext context) {
        try {

            ContactsBo contactsBo = BeanUtil.toBean(contactsVo, ContactsBo.class);

            //TODO:根据某个字段，查询数据库表中是否存在记录，不存在就新增，存在就更新
            ContactsVo contactsVo1 = null;

            //contactsVo1 = contactsService.selectBySomefield(contactsVo.getSomefield());
            if (ObjectUtil.isNull(contactsVo1)) {
                //不存在就新增
                setBo(contactsBo);
                ValidatorUtils.validate(contactsBo);
                boolean inserted = contactsService.insert(contactsBo);

                if (inserted) {
                    successNum++;
                    successMsg.append("<br/>").append(successNum).append("、通讯录 记录导入成功");
                } else {
                    failureNum++;
                    failureMsg.append("<br/>").append(failureNum).append("、通讯录 记录导入失败");
                }
            } else if (isUpdateSupport) {
                //存在就更新
                contactsBo.setId(contactsVo1.getId());//主键
                contactsBo.setVersion(contactsVo1.getVersion());
                boolean updated = contactsService.update(contactsBo);
                if (updated) {
                    successNum++;
                    successMsg.append("<br/>").append(successNum).append("、通讯录 记录更新成功");
                } else {
                    failureNum++;
                    failureMsg.append("<br/>").append(failureNum).append("、通讯录 记录更新失败");
                }
            }
        } catch (Exception e) {
            failureNum++;
            String msg = "<br/>" + failureNum + "、通讯录 记录导入失败：";
            failureMsg.append(msg).append(e.getMessage());
            log.error(msg, e);
        }
    }

    private void setBo(ContactsBo contactsBo) {
        contactsBo.setVersion(0);
        contactsBo.setCreateBy(loginUser.getUserId());
        contactsBo.setUpdateBy(loginUser.getUserId());
        contactsBo.setTenantId(loginUser.getTenantId());
    }

    @Override
    public void doAfterAllAnalysed(AnalysisContext context) {
        log.info("解析完成");
    }

    @Override
    public ExcelResult<ContactsImportVo> getExcelResult() {
        return new ExcelResult<>() {

            @Override
            public ExcelResultRes getAnalysis() {
                if (failureNum > 0 && successNum == 0) {
                    failureMsg.insert(0, "很抱歉，导入失败！共 " + failureNum + " 条数据没有成功导入，错误如下：");
                    return ExcelResultRes.builder().logInfo(failureMsg.toString()).status("0").build();
                } else if (failureNum > 0 && successNum > 0) {
                    failureMsg.insert(0, "很抱歉，部分导入失败！共 " + failureNum + " 条数据没有成功导入，错误如下：");
                    return ExcelResultRes.builder().logInfo(failureMsg.toString()).status("2").build();
                } else {
                    successMsg.insert(0, "恭喜您，数据已全部导入成功！共 " + successNum + " 条，数据如下：");
                    return ExcelResultRes.builder().logInfo(successMsg.toString()).status("1").build();
                }
            }

            @Override
            public List<ContactsImportVo> getList() {
                return null;
            }

            @Override
            public List<String> getErrorList() {
                return null;
            }
        };
    }
}
